// ArchiveCtrl.h : 錾уC^[tF[X̒`
//
// ---------------------------------------------------------------------------
//
//	CArchiveCtrl	A[JCuRg[NX
//					ZIP,LHA A[JCu DLL ̃bp[
//	
//	CREATE	2002.12.16	by HIRO <shirai@as.email.ne.jp>
//
// ---------------------------------------------------------------------------

#pragma once 

#include <TIME.H>
#include "UNLHA32.H"


// t@CXg\
typedef struct	{
	CHAR*	FileNameP;		// t@C(KKvTCY)
	WORD	Date;			// INDIVIDUALINFO	 wDate
	WORD 	Time;			// V				 wTime
	DWORD 	OriginalSize;	// V				 dwOriginalSize
	DWORD 	CompressedSize;	// V				 dwCompressedSize
} ARC_FILE_LIST;

// t
typedef struct	{
	INT		yy;
	INT		mm;
	INT		dd;
} YYMMDD;

// 
typedef struct	{
	INT		hh;
	INT		mm;
	INT		ss;
} HHMMSS;


// DLLGg[iZIPj
#define ZIP_OPENARCHIVE		"UnZipOpenArchive"
#define ZIP_CLOSEARCHIVE	"UnZipCloseArchive"
#define ZIP_FINDFIRST		"UnZipFindFirst"
#define ZIP_FINDNEXT		"UnZipFindNext"

// DLLGg[iLHAj
#define LHA_OPENARCHIVE		"UnlhaOpenArchive"
#define LHA_CLOSEARCHIVE	"UnlhaCloseArchive"
#define LHA_FINDFIRST		"UnlhaFindFirst"
#define LHA_FINDNEXT		"UnlhaFindNext"

// DLL֐vg^Cv
typedef HARC	(WINAPI * ARC_OPENARCHIVE)(const HWND,LPCSTR,const DWORD);
typedef int		(WINAPI * ARC_CLOSEARCHIVE)(HARC);
typedef int		(WINAPI * ARC_FINDFIRST)(HARC,LPCSTR,INDIVIDUALINFO*);
typedef int		(WINAPI * ARC_FINDNEXT)(HARC,INDIVIDUALINFO*);

// NX`
class	CArchiveCtrl	{
public:

	CArchiveCtrl();
	virtual	~CArchiveCtrl();

	// płgq
	enum	{
		ZIP		= 0,
		LHA		= 1
	};

	// e폈

	// A[JCut@CXg쐬
	ARC_FILE_LIST*	MakeArcFileList(
						INT		inMode,
						LPCSTR	inPathP,
						UINT	inMaxCount,
						UINT*	outCount = NULL);

	// A[JCut@CXgQƎo
	ARC_FILE_LIST*	GetArcFileList()	{return m_FileLisrP;};

	// A[JCut@CXg̎o
	INT	GetArcFileListCount()			{return m_ListCount;};


	// tϊ
	static	void	DosDate2Ymd(
						WORD	inWDate,
						YYMMDD*	outYmd);

	// ԕϊ
	static	void	DosTime2Hms(
						WORD	inWTime,
						HHMMSS*	outHms);

protected:

	// ΏۃA[JCo
	INT				m_Mode;
	HINSTANCE		m_DllH;


	// A[JCũt@CXg쐬ŗpp^

	UINT			m_ListMaxCount;		// 擾郊Xg̍ő匏
	UINT			m_ListCount;		// 擾Xǧ
	ARC_FILE_LIST*	m_FileLisrP;		// t@CXg

	void	AttachDll();				// DLL A^b`
	void	DetachDll();				// DLL f^b`
	void	PurgeFileList();			// t@CXg̔j

};

